import { Container } from "tstl/base/container/Container";
import { Iterator } from "tstl/base/iterator/Iterator";
import { ReverseIterator } from "tstl/base/iterator/ReverseIterator";
import { IEventDispatcher } from "./IEventDispatcher";
import { CollectionEvent } from "./CollectionEvent";
export declare class EventDispatcher<T, SourceT extends Container<T, SourceT, IteratorT, ReverseT>, IteratorT extends Iterator<T, SourceT, IteratorT, ReverseT>, ReverseT extends ReverseIterator<T, SourceT, IteratorT, ReverseT>> implements IEventDispatcher<T, SourceT, IteratorT, ReverseT> {
    /**
     * @hidden
     */
    private listeners_;
    constructor();
    dispatchEvent(event: CollectionEvent<T, SourceT, IteratorT, ReverseT>): boolean;
    hasEventListener(type: CollectionEvent.Type): boolean;
    addEventListener(type: CollectionEvent.Type, listener: CollectionEvent.Listener<T, SourceT, IteratorT, ReverseT>): void;
    removeEventListener(type: CollectionEvent.Type, listener: CollectionEvent.Listener<T, SourceT, IteratorT, ReverseT>): void;
}
//# sourceMappingURL=EventDispatcher.d.ts.map